/*
 * CreditCardImpl.java
 *
 * Created on February 26, 2002, 4:03 PM
 */

package unleashed.ch2;


import java.rmi.*;
import java.rmi.server.*;
import java.sql.*;

/**
 *
 * @author  Stephen Potts
 * @version
 */
public class CreditCardImpl extends UnicastRemoteObject implements Finder
{
    //JDBC variables
    java.sql.Connection dbConn = null;
    Statement statement1 = null;
    
    /** Creates new HelloServer */
    public CreditCardImpl() throws RemoteException, Exception
    {
        super();
        init();
    }
    
    
    //The init() method moves real processing out of the constructors where
    //Exception handling is simpler
    private void init() throws Exception
    {
        try
        {
            //Obtain connections to JDBC and JavaMail
            ConnectToServices();
            
        }catch(Exception e)
        {
            System.out.println("Exception thrown " + e);
        }
    }
    
    private void ConnectToServices()
    {
        try
        {
            //Get a connection to the datasource
            //load the driver class
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
            
            //Specify the ODBC data source
            String sourceURL = "jdbc:odbc:CruiseTicket";
            
            //get a connection to the database
            dbConn =DriverManager.getConnection(sourceURL);
            
            //If we get to here, no exception was thrown
            System.out.println("The database connection is " + dbConn);
            System.out.println("Making connection...\n");
            
            //Create the statement
            statement1 = dbConn.createStatement();
            
        } catch (Exception e)
        {
            System.out.println("Exception was thrown: " + e);
        }
    }
    
    public Object addCreditCardNumber(Object obj)
    throws RemoteException
    {
        try
        {
            Customer cust = (Customer)obj;
            int custID = cust.getCustID();
            
            String ccNum = "";
            
            //Populate the creditcard string string
            String getCCString =
            "SELECT CreditCardNumber FROM CruiseCustomer " +
            "WHERE CustomerID = " + Integer.toString(custID);
            
            ResultSet ccResults = statement1.executeQuery(getCCString);
            
            while (ccResults.next())
            {
                ccNum = ccResults.getString("CreditCardNumber");
            }
            
            cust.setCreditCardNumber(ccNum);
            
            return cust;
        }catch (Exception e)
        {
            System.out.println("Exception " + e);
            return null;
        }
    }
}