//object using the SAX parser.  
/*
 * TicketRequestParser.java
 *
 * Created on January 18, 2002, 3:01 PM
 */

package unleashed.ch3;

import unleashed.TicketRequest2;
import org.xml.sax.*;
import org.xml.sax.helpers.*;
import javax.xml.parsers.*;
import java.io.*;

/**
 *
 * @author  Stephen Potts
 * @version
 */
public class TicketRequestParser extends DefaultHandler
{
    private CharArrayWriter buffer = new CharArrayWriter();
    static TicketRequest2 tr2;
    String custIDString;
    String cruiseIDString;
    
    public void startDocument() throws SAXException
    {
        System.out.println("startDocument() called");
    }
    
    public void endDocument() throws SAXException
    {
        System.out.println("endDocument() called");
    }
    
    public void startElement(String namespaceURI, String localName,
    String qName, Attributes attr) throws SAXException
    {
        
        for ( int i=0; i < attr.getLength(); i++)
        {
            String attrName = attr.getQName(i);
            if (attrName.equals("custID"))
            {
                custIDString = attr.getValue(i);
            }
            if (attrName.equals("cruiseID"))
            {
                cruiseIDString = attr.getValue(i);
            }
        }
        buffer.reset();
    }
    
    public void endElement( String nameSpaceURI, String localName,
    String qName) throws SAXException
    {
        storeElementValue(qName);
    }
    
    public void characters( char[] ch, int start,
                             int length) throws SAXException
    {
        buffer.write(ch, start, length);
    }
    
    private void storeElementValue(String elementName)
    {
        if (elementName.equals("ticketRequest"))
        {
        }
        
        if (elementName.equals("customer"))
        {
            tr2.setCustID(Integer.parseInt(custIDString));
        }
        
        if (elementName.equals("lastName"))
        {
            tr2.setLastName(buffer.toString());
        }
        
        if (elementName.equals("firstName"))
        {
             tr2.setFirstName(buffer.toString());
        }
        
        if (elementName.equals("cruise"))
        {
            tr2.setCruiseID(Integer.parseInt(cruiseIDString));
        }
        
        if (elementName.equals("destination"))
        {
            tr2.setDestination(buffer.toString());
        }
        
        if (elementName.equals("port"))
        {
            tr2.setPort(buffer.toString());
        }
        
        if (elementName.equals("sailing"))
        {
            tr2.setSailing(buffer.toString());
        }
        
        if (elementName.equals("numberOfTickets"))
        {
            String numberOfTicketsString = buffer.toString(); 
            int numberOfTickets =
                           Integer.parseInt(numberOfTicketsString);
            tr2.setNumberOfTickets(numberOfTickets);
        }
        
        if (elementName.equals("isCommissionable"))
        {
            tr2.setCommissionable(true);
        }
    }
    
    public String toString()
    {
        return tr2.toString();
    }
    
    public static void main( String[] args)
    {

        System.out.println("TicketRequestParser main()");
        
        DefaultHandler trp = new TicketRequestParser();
        
        tr2 = new TicketRequest2();
        SAXParserFactory factory = SAXParserFactory.newInstance();
        try
        {
            SAXParser saxParser = factory.newSAXParser();
            saxParser.parse( new File(
             "c:/unleashed/ch3/ticketRequest.xml"),
                         trp);
        }catch (Exception e)
        {
            System.out.println("Exception in main " + e);
        }
        System.out.println(trp);
    }
}

