package unleashed.ch5.cruise;

import javax.rmi.*;
import java.util.*;
import javax.ejb.*;
import javax.naming.*;
import javax.servlet.http.*;
import java.io.*;
/**
 * Book ticket servlet 
 */
public class BookTicketServlet extends HttpServlet
{

	private static final String JNDI_NAME = "HelloWorld";

	protected void service(HttpServletRequest req, HttpServletResponse res) 
	{
	
    	res.setContentType("text/html");
		PrintWriter out = null;
    	try {
    
    	out = res.getWriter();
    
    
      		
            String cruiseName = req.getParameterValues("cruiseName")[0];
			//make a booking
			Context ctx = getInitialContext();
			Object obj = ctx.lookup("TicketingAgent");

			TicketingAgentHome home = 
			(TicketingAgentHome)PortableRemoteObject.narrow(obj, 
			TicketingAgentHome.class);
			
			//create a bean
			Object ejbObj = home.create();

			//cast the bean to our interface
			TicketingAgent ta = 
			(TicketingAgent)PortableRemoteObject.narrow(ejbObj, 
			TicketingAgent.class);
	
			ta.bookTicket(cruiseName);		
			
			
            // Respond to client 
      		out.println("<html>");
      		out.println("<h4>You have booked a ticket on a cruise to " +cruiseName + "!<h4>");
			System.out.println("Booking for " + cruiseName);
			out.println("<BR>");
			out.println("<BR>");
			out.println("<a href='/cruise/bookings.jsp'>See your bookings</a>");
      		out.println("</html>");
      
    		} catch(Exception e) {
      			e.printStackTrace();
      			out.println("Please try again.");
    		}
	
	}
	
	public Context getInitialContext() throws Exception 
	{
        Properties p = new Properties();
        p.put(Context.INITIAL_CONTEXT_FACTORY,
              "weblogic.jndi.WLInitialContextFactory");
        p.put(Context.PROVIDER_URL, "t3://localhost:7001");
		
        return new InitialContext(p);
     }

 
}
