package unleashed.ch5.cruise;

import javax.ejb.*;
import javax.naming.*;
import java.util.*;
import javax.rmi.*;

/**
 * Ticketing Agent Bean Implementation.
 */
public class TicketingAgentBean implements SessionBean 
{
  
  //callback method must be implemented
  public void ejbActivate() {}
  public void ejbRemove() {}
  public void ejbPassivate() {}
  
  public void setSessionContext(SessionContext ctx)
  {
  
  	//retrieve environment entry ApplicationName
	try
	{
  		//get environment initial context 
		InitialContext env = new InitialContext();
		String appName = (String)env.lookup("ApplicationName");
		System.out.println("Application Name entry is: " + appName);
		
	    
	}catch(Exception e)
	{
		System.out.println(e.getMessage());
		e.printStackTrace();
	}
  }
  
  public void ejbCreate () throws CreateException {}


  /**
   * Gets all available tickets
   */
	public Ticket[] getAvailableTickets() 
	{
		Ticket[] tickets = new Ticket[3];
		Ticket ticket = new Ticket("Aruba", "Sunny Cruise",
		5, "New York");

		Ticket ticket1 = new Ticket("Alaska", "Chilly Cruise",
		5, "San Francisco");
		
		Ticket ticket2 = new Ticket("Spain", "", 8, "New York");		
		
		tickets[0] = ticket;
		tickets[1] = ticket1;
		tickets[2] = ticket2;
		return tickets;		
	}
	
	/**
	* Books a ticket
	*/
	public void bookTicket(String cruiseName)
	throws BookingFailedException
	{
		//Book the tickets
		try
		{
		
			//get JNDI initial context
	  		Properties h = new Properties();
      		h.put(Context.INITIAL_CONTEXT_FACTORY,
              "weblogic.jndi.WLInitialContextFactory");
			String url = "t3://localhost:7001";	  
      		  h.put(Context.PROVIDER_URL, url);
      		InitialContext itc = new InitialContext(h);
		
			//get booking home 
	    	Object obj = (BookingHome) itc.lookup("Booking");
        	BookingHome bHome = (BookingHome) PortableRemoteObject.narrow(obj, BookingHome.class);
		
			
			bHome.create(cruiseName);
		}catch(Exception e)
		{
			System.err.println("Exception creating a Booking Bean: " 
			+ e.getMessage());
			e.printStackTrace();
			throw new BookingFailedException(e.getMessage());
		}
	}
}








