package unleashed.ch5.simple;

import java.rmi.RemoteException;
import java.util.Properties;
import javax.ejb.CreateException;
import javax.ejb.RemoveException;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;

/**
 * Simple client
 */
public class SimpleEJBClient 
{

	private static final String JNDI_NAME = "HelloWorld";

 
	public static void main(String[] args) 
	throws Exception 
	{
   
    	try 
		{
			//jndi properties
			Properties h = new Properties();
      		h.put(Context.INITIAL_CONTEXT_FACTORY,
        		"weblogic.jndi.WLInitialContextFactory");
      		h.put(Context.PROVIDER_URL, 
				"t3://localhost:7001");
	  
	  		//lookup jndi initial context
			InitialContext ctx = new InitialContext(h);
			
			//lookup home 
			Object obj = ctx.lookup(JNDI_NAME);
			
			//cast home 
			HelloWorldHome home = 
			(HelloWorldHome)PortableRemoteObject.narrow(obj, HelloWorldHome.class);
			
			//create the bean
			Object ejbObj = home.create();
			
			//cast the bean to our interface
			HelloWorld simpleEJB = 
			(HelloWorld)PortableRemoteObject.narrow(ejbObj, HelloWorld.class);
			
			//call bean's method
			System.out.println("Calling Simple EJB: " + simpleEJB.sayIt());
			
    	} catch (Exception e) 
		{
      		System.out.println(e.getMessage());
			e.printStackTrace();
    	}	 

    
	}

  
}
