/*
 * SimpleQueueBean.java
 *
 * Created on January 9, 2002, 7:39 PM
 */

package unleashed.ch6.SimpleQueue;

import weblogic.rmi.RemoteException;

import javax.ejb.CreateException;
import javax.ejb.MessageDrivenBean;
import javax.ejb.MessageDrivenContext;

import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.TextMessage;

import javax.naming.InitialContext;
import javax.naming.NamingException;

/**
 *
 * @author Steve Potts
 */
public class SimpleQueueBean implements MessageDrivenBean, MessageListener
{
    private MessageDrivenContext context;
  
    public void ejbActivate()
    {
        log("SimpleQueueBean ejbActivate called");
    }
    
    
    public void ejbRemove()
    {
        log("SimpleQueueBean ejbRemove called");
    }
    
    public void ejbPassivate()
    {
        log("SimpleQueueBean ejbPassivate called");
    }
    
    /**
     * Sets the session context.  We don't do anything with it in this example
     *
     * @param ctx               MessageDrivenContext Context for session
     */
    public void setMessageDrivenContext(MessageDrivenContext ctx)
    {
        log("SimpleQueueBean setMessageDrivenContext called");
        context = ctx;
    }
    
    
    public void ejbCreate() throws CreateException
    {
        log("SimpleQueueBean ejbCreate called");
        
    }
    
    /////
    // Implementation of MessageListener
    //
    public void onMessage(Message msg)
    {
        TextMessage tm = (TextMessage) msg;
        try
        {
            String text = tm.getText();
            log("SimpleQueueBean : " + text);
        }
        catch(JMSException ex)
        {
            ex.printStackTrace();
        }
    }
    
    
    // logging
    private void log(String s)
    {
        System.out.println(s);
    }

}
