package unleashed.ch9.payment; 

/**
 * PaymentAgentBindingClient
 */
public class PaymentAgentClient
{

    public  static void main(String args[])
    {
        if (args.length != 4)
        {
            System.out.println("USAGE: PaymentAgentClient CreditCardName CreditCardNumber ExpiryDate Amount");
            System.exit(1);
        }
        
        try
        {
        
            CreditCardInfo info = new CreditCardInfo(args[0], args[1], args[2], Double.parseDouble(args[3]));
            PaymentAgentClient client = new PaymentAgentClient();
       
            client.processPayment(info);
        
        }catch(Exception e)
        {
            e.printStackTrace();
        }
    }
    
    
    public void processPayment(CreditCardInfo info) 
    throws java.rmi.RemoteException, java.net.MalformedURLException
    {
        paBindingClient client = paBindingClientFactory.create();
        
        System.out.println("PaymentAgent web service proxy is created");
        System.out.println("Processing payment for " + info.toString());
        client.processPayment(info);
    }

}