/*
 * ICBinder.java
 *
 * Created on January 28, 2002, 2:28 PM
 */
package unleashed.ch11;

import java.io.*;
import java.util.*;
import javax.transaction.*;
import javax.naming.*;
import javax.jms.*;

/** This example shows how to establish a connection to the
 * InitialContext object on a WebLogic Server installation.
 * It also shows the contents of the InitialContext.
 *
 * This example runs in the same package as the JMS 
 * queue examples. Copy this file to the same directory and run ant.
 * Follow the instructions that come with WebLogic Server on running
 * the examples that ship with the product on setting up the sample 
 * server.
 *
 * @author Steve Potts
 */

public class ICBinder
{

  public static void main(String[] args) 
  {
     try
     {
        System.out.println("The Java Unleashed ICBinder");
     
        //Specify the URL of the naming service provider.  In this
        //case it is my computer
        String url = "t3://localhost:7001";
     
        //Use the hashtable approach to getting the InitialContext
        Hashtable env = new Hashtable();
     
        //Specify that we want the WebLogic context factory to be run
        env.put(Context.INITIAL_CONTEXT_FACTORY,
             "weblogic.jndi.WLInitialContextFactory");
        env.put(Context.PROVIDER_URL, url);
     
        //Create the InitialContext
        InitialContext ic = new InitialContext(env);

        //Create a String object
	  String obj1 = new String("Mary Ann");

	  //Bind the String Object to the name "Girl Friend"
	  ic.bind("Girl Friend", obj1);

	  //Do a lookup on the name "Girl Friend");
        String obj2 = (String)ic.lookup("Girl Friend");
        System.out.println("The Girl Friend is " + obj2);

        //Change girls friends
	  obj1 = "Katie";
	  ic.rebind("Girl Friend", obj1);

	  //Do a lookup on the name "Girl Friend");
        obj2 = (String)ic.lookup("Girl Friend");
        System.out.println("The Girl Friend is now " + obj2);

	  try
	  {
	      ic.unbind("Girl Friend");
            obj2 = (String)ic.lookup("Girl Friend");
        }catch(NameNotFoundException nnfe)
        {
            System.out.println("No name was found for Girl Friend");
        }
      }catch (NamingException e)
	{
		System.out.println("NamingException thrown " + e);
      }
  }//main
}//class
