
//Listing 11.2 Some development environments have a default URL
//and InitialContext setup.
package unleashed.ch11;

import java.io.*;
import java.util.*;
import javax.transaction.*;
import javax.naming.*;
import javax.jms.*;

/** This example shows how to establish a connection to the
 * InitialContext object on a WebLogic Server installation.
 * It also shows the contents of the InitialContext.
 *
 * This example runs in the same package as the JMS 
 * queue examples. Copy this file to the same directory and run ant.
 * Follow the instructions that come with WebLogic Server on running
 * the examples that ship with the product on setting up the sample 
 * server.
 *
 * @author Steve Potts
 */

public class ICDefaultLocator
{

  public static void main(String[] args) 
  {
     try
     {
        System.out.println("The Java Unleashed ICDefaultLocator");
     
        //Create the InitialContext
        InitialContext ic = new InitialContext();
        System.out.println("The InitialContext object is " + ic);

        //Next find out the name of this context in its own namespace
        String myContextName = ic.getNameInNamespace();
        System.out.println("The InitialContext object's name is "
                        + myContextName);
     
        //Create an Enumeration of the name/object type pairs
        NamingEnumeration ne = ic.list(myContextName);
        System.out.println("The Naming Enumeration is " + ne);

        if(ne.hasMore())
        {
           System.out.println("First Element is " + ne.next());
        }else
	  {
		System.out.println("Context has no elements");
	  }
      }catch (NamingException e)
	{
		System.out.println("NamingException thrown " + e);
      }

  }//main
}//class
