/*
 * LookupCompany.java
 *
 * Created on January 28, 2002, 3:06 PM
 */

//Listing 11.11 LookupCompany verifies that the Serializing mechanism 
//is working properly
package unleashed.ch11;

import java.io.ObjectInputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Iterator;
import java.util.Hashtable;
import javax.naming.*;


/**
 *
 * @author  Stephen Potts
 * Test the restoration of bound objects
 */
public class LookupCompany {

    /** Creates new LookupCompany */
    public LookupCompany() {
    }
    
    public static void printCompanyObject(Company c)
    {
        System.out.println("The company name is " + c.getName());
        System.out.println("The company president is " + c.getPresident().getName());
        System.out.println(" ");

        Iterator i = c.getDepartmentIterator();
        while (i.hasNext())
        {
            Department d = (Department)i.next();
            System.out.println("   The department name is " + d.getName());
            System.out.println("   The department manager is " + d.getManager().getName());
            System.out.println(" ");
        }
    }
    public static void main(String[] args)
    {
        try
        {
            


            System.out.println("The Java Unleashed LookupCompany");
     
            //Specify the URL of the naming service provider.  In this
            //case it is my computer
            String url = "t3://localhost:7001";
            System.out.println("The URL of the InitialContext object is "
                         + url);
     
            //Use the hashtable approach to getting the InitialContext
            Hashtable env = new Hashtable();
     
            //Specify that we want the WebLogic context factory to be run
            env.put(Context.INITIAL_CONTEXT_FACTORY,
             "weblogic.jndi.WLInitialContextFactory");
            env.put(Context.PROVIDER_URL, url);
     
            //Create the InitialContext
            InitialContext ic = new InitialContext(env);

	      //Do a lookup on the name "Girl Friend");
            Company comp = (Company)ic.lookup("XYZ Company");

            printCompanyObject(comp);


        }catch (NamingException ne)
        {
            System.out.println("NamingException thrown " + ne);
        }
    }
}
