/*
 * HelloRecognize.java
 *
 * Created on March 11, 2002, 9:53 PM
 */

package unleashed.ch12;

/**
 *
 * @author  Stephen Potts
 * @version
 */

import javax.speech.*;
import javax.speech.recognition.*;
import java.io.FileReader;
import java.util.Locale;

public class HelloRecognizer extends ResultAdapter
{
    
    static Recognizer recognizer;
    String gst;
    
    public void resultAccepted(ResultEvent re)
    {
        try
        {
        Result res = (Result)(re.getSource());
        ResultToken tokens[] = res.getBestTokens();
        
        for (int i=0; i < tokens.length; i++)
        {
            gst = tokens[i].getSpokenText();
            System.out.print(gst + " ");
        }
        System.out.println();
        
        if(gst.equals("bye"))
        {
            System.out.println("See you later!");
            recognizer.deallocate();
            System.exit(0);
        }
        }catch(Exception ee)
        {
            System.out.println("Exception " + ee);
        }
    }
    
    public static void main(String args[])
    {
        try
        {
            recognizer = Central.createRecognizer(
                 new EngineModeDesc(Locale.ENGLISH));
            recognizer.allocate();
            
            FileReader grammar1 = 
             new FileReader("c:/unleashed/ch12/SimpleGrammar.txt");
            
            RuleGrammar rg = recognizer.loadJSGF(grammar1);
            rg.setEnabled(true);
            
            recognizer.addResultListener(new HelloRecognizer());
            
            System.out.println("Ready for Input");
            recognizer.commitChanges();
            
            recognizer.requestFocus();
            recognizer.resume();
        }catch (Exception e)
        {
            System.out.println("Exception  " + e);
        }
    }
           
}