/*
 * HelloThread.java
 *
 * Created on March 5, 2002, 3:32 PM
 */

package unleashed.ch12;

/**
 *
 * @author  Stephen Potts
 * @version
 */
import javax.speech.*;
import javax.speech.synthesis.*;
import java.util.Locale;

public class HelloThread
{
    
    public static void main(String args[])
    {
        Engine eng;
        try
        {
            // Create a synthesizer for English
            final Synthesizer synth = Central.createSynthesizer(
            new SynthesizerModeDesc(Locale.ENGLISH));
            
            new Thread(new Runnable()
            {
                public void run()
                {
                    try
                    {
                        synth.allocate();
                    }catch (Exception e)
                    {
                        System.out.println("Exception " + e);
                    }
                }
            }).start();
            
            //Add the rest of you initialization code here
            
            
            //wait for the engine to get ready
            synth.waitEngineState(Engine.ALLOCATED);
            synth.resume();
            
            // Speak the "Hello, Thread" string
            synth.speakPlainText("Hello, Thread!", null);
            System.out.println(
            "You should be hearing Hello, Thread now.");
            
            
            // Wait till speaking is done
            synth.waitEngineState(Synthesizer.QUEUE_EMPTY);
            
            // release the resources
            synth.deallocate();
        } catch (Exception e)
        {
            e.printStackTrace();
        }
    }
}