/*
 * HelloUnleashedStates.java
 *
 * Created on March 5, 2002, 3:32 PM
 */

package unleashed.ch12;

/**
 *
 * @author  Stephen Potts
 * @version
 */
import javax.speech.*;
import javax.speech.synthesis.*;
import java.util.Locale;

public class HelloUnleashedStates
{
    private static void printState(Synthesizer synth)
    {
        System.out.println("The current States are:");
        if(synth.testEngineState(Synthesizer.QUEUE_EMPTY))
            System.out.println("State = QUEUE_EMPTY");
        if(synth.testEngineState(Synthesizer.QUEUE_NOT_EMPTY))
            System.out.println("State = QUEUE_NOT_EMPTY");
        if(synth.testEngineState(Engine.ALLOCATED))
            System.out.println("State = ALLOCATED");
       if(synth.testEngineState(Engine.DEALLOCATED))
            System.out.println("State = DEALLOCATED");
        if(synth.testEngineState(Engine.ALLOCATING_RESOURCES))
            System.out.println("State = ALLOCATING_RESOURCES");
        if(synth.testEngineState(Engine.DEALLOCATING_RESOURCES))
            System.out.println("State = DEALLOCATING_RESOURCES");
        
        
        
        if(synth.testEngineState(Engine.RESUMED))
            System.out.println("State = RESUMED");
        if(synth.testEngineState(Engine.PAUSED))
            System.out.println("State = PAUSED");
        
    }
        
    public static void main(String args[])
    {
        try
        {
            // Create a synthesizer for English
            Synthesizer synth = Central.createSynthesizer(
            new SynthesizerModeDesc(Locale.ENGLISH));
            printState(synth);
            synth.allocate();
            printState(synth);
            synth.resume();
            printState(synth);
            
            // Speak the "Hello, Unleashed States" string
            synth.speakPlainText("Hello, Unleashed States!", null);
            printState(synth);
            
            // Wait till speaking is done
            synth.waitEngineState(Synthesizer.QUEUE_EMPTY);
            printState(synth);
            
            // release the resources
            synth.deallocate();
            printState(synth);
        } catch (Exception e)
        {
            e.printStackTrace();
        }
    }
}