/*
 * PortWriter.java
 *
 * Created on February 8, 2002, 4:40 PM
 */

package unleashed.ch14;
import java.io.*;
import javax.comm.*;
import java.util.*;

/**
 *
 * @author  Stephen Potts
 * @version
 */
public class PortWriter
{
    static Enumeration ports;
    static CommPortIdentifier pID;
    static OutputStream outStream;
    SerialPort serPort;
    static String messageToSend = "Tell everyone what a great book this is!\n";
    
    /** Creates new PortFinder */
    public PortWriter()
    {
        try
        {
            serPort = (SerialPort)pID.open("PortWriter",2000);
        }catch (PortInUseException piue)
        {
            System.out.println("Exception " + piue);
        }
        
        try
        {
            outStream = serPort.getOutputStream();
        }catch (IOException ioe)
        {
            System.out.println("Exception " + ioe);
        }
        
        try
        {
            serPort.setSerialPortParams(9600, SerialPort.DATABITS_8,
            SerialPort.STOPBITS_1,
            SerialPort.PARITY_NONE);
        }catch (UnsupportedCommOperationException ucoe)
        {
            System.out.println("Exception " + ucoe);
        }
    }//Constructor
    
    
    public static void main(String[] args)
    {
        ports = CommPortIdentifier.getPortIdentifiers();
        
        while(ports.hasMoreElements())
        {
            pID = (CommPortIdentifier)ports.nextElement();
            System.out.println("Port " + pID.getName());
            
            if (pID.getPortType() == CommPortIdentifier.PORT_SERIAL)
            {
                if (pID.getName().equals("COM1"))
                {
                    PortWriter pWriter = new PortWriter();
                    System.out.println("COM1 found");
                }
            }
        }
        try
        {
            outStream.write(messageToSend.getBytes());
            System.out.println("The message was sent");
        }catch (IOException ioe)
        {
            System.out.println("Exception " + ioe);
        }
    }//main()
}//class
