//Listing 19.1 The clicking of a button causes the actionPerformed() method to be called.
/*
 * EventTest.java
 *
 * Created on January 24, 2002, 11:17 AM
 */

package unleashed.ch19;


import javax.swing.*;
import java.awt.event.ActionListener;
import javax.swing.border.EtchedBorder;
import java.awt.Container;
import java.awt.BorderLayout;

import java.util.*;

/**
 *
 * @author  Stephen Potts
 * @version
 */
public class EventCreator extends JFrame
{
    JButton btnBook;
    JButton btnExit;
    
    /** Constructors for CruiseList */
    public EventCreator() throws Exception
    {
        init();
    }
    
    public EventCreator(String caption) throws Exception
    {
        super(caption);
        init();
    }
    
    //The init() method moves real processing out of the constructors
    //where Exception handling is simpler
    private void init() throws Exception
    {
        try
        {
            //configure the Frame
            EventConsumer ec = new EventConsumer();
            setBounds(150,200,500,250);
            setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
            
            //set the layout
            BorderLayout border = new BorderLayout();
            Container content = getContentPane();
            content.setLayout(border);
            btnBook = new JButton("Book");
            btnExit = new JButton("Exit");
            btnBook.addActionListener(ec);
            btnExit.addActionListener(ec);
            
            JPanel bottomPanel = new JPanel();
            bottomPanel.add(btnBook);
            bottomPanel.add(btnExit);
            content.add(bottomPanel, BorderLayout.SOUTH);
            setVisible(true);
        }catch(Exception e)
        {
            System.out.println("Exception thrown " + e);
        }
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[])
    {
        //create an instance of the GUI
        try
        {
            EventCreator mainWindow = new EventCreator("EventCreator");
        }catch(Exception e)
        {
            System.out.println("Exception in main " + e);
        }
    }

}//class
