package unleashed.ch21.bd;

import java.util.*;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;
/**
* Business Delegate class represents a server EJB hiding it from the 
* the rest of the client classes
*/
public class BusinessDelegate
{
	
	protected String JNDI_NAME = "ServerBean";
	
	public String businessMethod()
	throws BusinessException
	{
		Server server = lookupServer();
		
		System.out.println("Business delegate is calling server");
		try
		{
			return server.serverMethod();
		}catch(java.rmi.RemoteException e)
		{
			throw new BusinessException(e);
		}
	}
	
	protected Server lookupServer()
	throws BusinessException
	{
			try 
		{
			//jndi properties
			Properties h = new Properties();
      		h.put(Context.INITIAL_CONTEXT_FACTORY,
        		"weblogic.jndi.WLInitialContextFactory");
      		h.put(Context.PROVIDER_URL, "t3://localhost:7001");
	  
	  		//lookup jndi initial context
			InitialContext ctx = new InitialContext(h);
			
			//lookup home 
			Object obj = ctx.lookup(JNDI_NAME);
			
			//cast home 
			ServerHome home = (ServerHome)PortableRemoteObject.narrow(obj, ServerHome.class);
			
			//create the bean
			Object ejbObj = home.create();
			
			//cast the bean to our interface
			Server serverEJB = (Server)PortableRemoteObject.narrow(ejbObj, Server.class);
			
			return serverEJB;
			
    	} catch (Exception e) 
		{
      		System.out.println(e.getMessage());
			e.printStackTrace();
			throw new BusinessException(e);
    	}	 
	}
}
