package unleashed.ch21.command;

import java.rmi.RemoteException;
import java.util.Properties;
import javax.ejb.CreateException;
import javax.ejb.RemoveException;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;

/**
 * Command client
 */

public class CommandClient 
{

	private static final String JNDI_NAME = "CommandProcessor";

	
 
	public static void main(String[] args) throws Exception 
	{
   
    	try 
		{
			//jndi properties
			Properties h = new Properties();
      		h.put(Context.INITIAL_CONTEXT_FACTORY,
        		"weblogic.jndi.WLInitialContextFactory");
      		h.put(Context.PROVIDER_URL, "t3://localhost:7001");
	  
	  		//lookup jndi initial context
			InitialContext ctx = new InitialContext(h);
			
			//lookup home 
			Object obj = ctx.lookup(JNDI_NAME);
			
			//cast home 
			CommandProcessorHome home = (CommandProcessorHome)PortableRemoteObject.narrow(obj, CommandProcessorHome.class);
			
			//create the bean
			Object ejbObj = home.create();
			
			//cast the bean to our interface
			CommandProcessor commandEJB = (CommandProcessor)PortableRemoteObject.narrow(ejbObj, CommandProcessor.class);
			
			Command operation = new Operation();
			
			//call bean's method
			System.out.println("Sending command to command processor bean");
			
			System.out.println("Command returned result: " + commandEJB.executeCommand(operation));
			
    	} catch (Exception e) 
		{
      		System.out.println(e.getMessage());
			e.printStackTrace();
    	}	 

    
	}

  
}
