package unleashed.ch21.command;

import javax.ejb.CreateException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import javax.naming.InitialContext;
import javax.naming.NamingException;

/**
 * Command Processor bean implementation.
 */
public class CommandProcessorBean implements SessionBean 
{

  //callback method must be implemented
  public void ejbActivate() {}
  public void ejbRemove() {}
  public void ejbPassivate() {}
  public void setSessionContext(SessionContext ctx) {}
  public void ejbCreate () throws CreateException {}


  /**
   * Facade method implementation
   */
	public String executeCommand(Command command) 
	{
	
		return command.execute();
	}
}