/*
 * I18nOnly.java
 *
 * Created on February 6, 2002, 11:17 AM
 */

package unleashed.ch25;
import java.util.Locale;
import java.util.*;

/**
 *
 * @author  Stephen Potts
 * @version
 */
public class I18nOnly
{
    
    /** Creates new I18nOnly */
    public I18nOnly()
    {
    }
    
    public static void main(String[] args)
    {
        String lang = "";
        String country = "";
        String variant = "";
        Locale loc;
        ResourceBundle vocabulary;
        
        //if they passed in a lang and country, use it.  Else
        //default to US English
        if (args.length == 2)
        {
            lang = args[0];
            country = args[1];
        }
        
        if (args.length == 3)
        {
            lang = args[0];
            country = args[1];
            variant = args[2];
            loc = new Locale(lang, country, variant);
        }else
        {
            //Create the Locale object
            loc = new Locale(lang, country);
        }
        
        //get the right resource bundle for this locale
        vocabulary = ResourceBundle.getBundle("unleashed.ch25.VocabBundle", loc);
        
        //Print some messages from this bundle
        System.out.println(vocabulary.getString("greet"));
        System.out.println(vocabulary.getString("farewell"));
        System.out.println(vocabulary.getString("wishSuccess"));
        System.out.println(vocabulary.getString("edible"));
    }
}