package unleashed.ch26;
import java.util.Vector;
import java.util.Iterator;
import java.util.Date;
import java.io.*;

/**
 *
 * @author  Stephen Potts
 * this version has the serversionUID set manually
 */
public class Company3 implements Serializable
{
    private String name;
    private Employee president;
    private Vector departments;
    private transient String dateLastMarshaled;
 

    /** Creates new Company */
    public Company3(String name)
    {
        this.name = name;
        departments = new Vector();
    }
    
    public String getName()
    {
        return this.name;
    }
    
    public void addDepartment(Department dept)
    {
        departments.addElement(dept);
    }
    
    public Employee getPresident()
    {
        return this.president;
    }
    
    public void addPresident(Employee e)
    {
        this.president = e;
    }
    
    public String getDateLastMarshaled()
    {
        return this.dateLastMarshaled;
    }
    
    public Iterator getDepartmentIterator()
    {
        return departments.iterator();
    }
    
    //add a custom writeObject() and readObject() to do your own serialization
    private void writeObject(ObjectOutputStream stream)throws IOException
    {
        stream.defaultWriteObject();
        stream.writeObject(new Date().toString());
    }  
    
    private void readObject(ObjectInputStream stream) throws IOException
    {
        try
        {
            stream.defaultReadObject();
            this.dateLastMarshaled = (String)(stream.readObject());
        }catch (ClassNotFoundException cnfe)
        {
            System.out.println("Class Not Found " + cnfe);
        }
    }         
}
