
//Listing 26.6 The TestSerCompany class tests the serialization of this complex set of classes
package unleashed.ch26;
import java.io.ObjectOutputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Iterator;

/**
 *
 * @author  Stephen Potts
 * Test to see if company is serializable 
 */
public class TestSerCompany
{

    /** Creates new TestSerCompany */
    public TestSerCompany() {
    }
    
    public static void printCompanyObject(Company c)
    {
        System.out.println("The company name is " + c.getName());
        System.out.println("The company president is " + c.getPresident().getName());
        System.out.println(" ");

        Iterator i = c.getDepartmentIterator();
        while (i.hasNext())
        {
            Department d = (Department)i.next();
            System.out.println("   The department name is " + d.getName());
            System.out.println("   The department manager is " + d.getManager().getName());
            System.out.println(" ");
        }
    }
            
        
        
    public static void main(String[] args)
    {
        try
        {
            String filename = "Company.ser";
            
            Company comp = new Company("The Blazer Company");
            Employee emp0 = new Employee("Leslie Waller");
            comp.addPresident(emp0);
        
            Department sales = new Department("Sales");
            Employee emp1 = new Employee("Grant Jackson");
            sales.addManager(emp1);
            comp.addDepartment(sales);
            
            Department accounting = new Department("Accounting");
            Employee emp2 = new Employee("Clay Cain");
            accounting.addManager(emp2);
            comp.addDepartment(accounting);
           
            Department maintenance = new Department("Maintenance");
            Employee emp3 = new Employee("Greg Hladlick");
            maintenance.addManager(emp3);
            comp.addDepartment(maintenance);
            printCompanyObject(comp);

            FileOutputStream f  = new FileOutputStream(filename);
            ObjectOutputStream oos = new ObjectOutputStream(f);
            oos.writeObject(comp);
            oos.close();
            
           
        }catch (IOException ioe)
        {
            System.out.println("IOException thrown " + ioe);
        }
    }
}

